<script setup lang="ts">
import { onMounted, ref } from 'vue'

const X_CLASS = ref('x')
const CIRCLE_CLASS = ref('circle')
const circleTurn = ref(true)
const WINNING_COMBINATION = ref([
  [0, 1, 2],
  [3, 4, 5],
  [6, 7, 8],
  [0, 3, 6],
  [1, 4, 7],
  [2, 5, 8],
  [0, 4, 8],
  [2, 4, 6]
])

const placeMark = (cell: HTMLElement, currentClass: string) => {
  if (cell === null) return

  cell.classList.add(currentClass)
}
const startGame = () => {
  const winEl = document.getElementById('winningMessage')
  if (winEl === null) return

  circleTurn.value = false
  setBoardHoverClass()
  winEl.classList.remove('show')
}
const checkWin = (currentClass: string) =>
  WINNING_COMBINATION.value.some((combination) =>
    combination.every((index) =>
      document.querySelectorAll('[data-cell]')[index].classList.contains(currentClass)
    )
  )
const isDraw = () =>
  [...document.querySelectorAll('[data-cell]')].every(
    (cell) => cell.classList.contains(X_CLASS.value) || cell.classList.contains(CIRCLE_CLASS.value)
  )
const endGame = (draw: boolean) => {
  const winElText = document.querySelector('[data-winning-message-text]')
  const winEl = document.getElementById('winningMessage')

  if (winElText === null) return
  if (winEl === null) return

  if (draw) {
    winElText.textContent = 'Draw!'
  } else {
    winElText.textContent = `${circleTurn.value ? "O's" : "X's"} Wins!`
  }

  winEl.classList.add('show')
}
const swapTurns = () => (circleTurn.value = !circleTurn.value)
const setBoardHoverClass = () => {
  const board = document.getElementById('board')
  if (board === null) return

  board.classList.remove(X_CLASS.value)
  board.classList.remove(CIRCLE_CLASS.value)

  if (circleTurn.value) board.classList.add(CIRCLE_CLASS.value)
  else board.classList.add(X_CLASS.value)
}
const handleClick = (e: MouseEvent) => {
  const cell = e.target as HTMLElement
  const currentClass = circleTurn.value ? CIRCLE_CLASS.value : X_CLASS.value

  placeMark(cell, currentClass)

  if (checkWin(currentClass)) {
    endGame(false)
  } else if (isDraw()) {
    endGame(true)
  } else {
    swapTurns()
    setBoardHoverClass()
  }
}
const reload = () => window.location.reload()

onMounted(startGame)
</script>

<template>
  <div id="tictactoe">
    <div class="board" id="board">
      <div class="cell" data-cell @click.once="handleClick" v-for="i in 9" :key="i"></div>
    </div>

    <div class="winning-message" id="winningMessage">
      <div data-winning-message-text></div>
      <button id="restartButton" @click="reload">Restart</button>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.board {
  width: 100vw;
  height: 100vh;
  display: grid;
  justify-content: center;
  align-content: center;
  justify-items: center;
  align-items: center;
  grid-template-columns: repeat(3, auto);

  & .cell {
    width: var(--cell-size);
    height: var(--cell-size);
    border: 1px solid black;
    display: flex;
    justify-content: center;
    align-items: center;
    position: relative;
    cursor: pointer;

    &:first-child,
    &:nth-child(2),
    &:nth-child(3) {
      border-top: none;
    }

    &:nth-child(3n + 1) {
      border-left: none;
    }

    &:nth-child(3n + 3) {
      border-right: none;
    }

    &:last-child,
    &:nth-child(7),
    &:nth-child(8) {
      border-bottom: none;
    }

    &.x,
    &.circle {
      cursor: not-allowed;
    }

    &.x::before,
    &.x::after,
    &.circle::before {
      background-color: black;
    }
  }
}

.board.x .cell:not(.x):not(.circle):hover::before,
.board.x .cell:not(.x):not(.circle):hover::after,
.board.circle .cell:not(.x):not(.circle):hover::before {
  background-color: lightgrey;
}

.cell.x::before,
.cell.x::after,
.board.x .cell:not(.x):not(.circle):hover::before,
.board.x .cell:not(.x):not(.circle):hover::after {
  content: '';
  position: absolute;
  width: calc(var(--mark-size) * 0.15);
  height: var(--mark-size);
}

.cell.x::before,
.board.x .cell:not(.x):not(.circle):hover::before {
  transform: rotate(45deg);
}

.cell.x::after,
.board.x .cell:not(.x):not(.circle):hover::after {
  transform: rotate(-45deg);
}

.cell.circle::before,
.cell.circle::after,
.board.circle .cell:not(.x):not(.circle):hover::before,
.board.circle .cell:not(.x):not(.circle):hover::after {
  content: '';
  position: absolute;
  border-radius: 50%;
}

.cell.circle::before,
.board.circle .cell:not(.x):not(.circle):hover::before {
  width: var(--mark-size);
  height: var(--mark-size);
}

.cell.circle::after,
.board.circle .cell:not(.x):not(.circle):hover::after {
  width: calc(var(--mark-size) * 0.7);
  height: calc(var(--mark-size) * 0.7);
  background-color: white;
}

.winning-message {
  display: none;
  position: fixed;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  background-color: rgba(0, 0, 0, 0.9);
  justify-content: center;
  align-items: center;
  color: white;
  font-size: 5rem;
  flex-direction: column;

  &.show {
    display: flex;
  }

  & button {
    font-size: 3rem;
    background-color: white;
    border: 1px solid black;
    padding: 0.25em 0.5em;
    cursor: pointer;

    &:hover {
      background-color: black;
      color: white;
      border-color: white;
    }
  }
}
</style>
